//==================================================
/*
	This is file of macroses for NOTES3.NOT, version 3.5
*/
//==================================================
#define LPARAM 256
#define MAXPARAM 5
#define MAXINPUTLINE 255
#define MAXLINES 100

char namemacro[LPARAM];
char param[MAXPARAM+1][LPARAM];	// param[1] = namemacro
int nparams;	// number of parameters in macro call

//int soundonoff = 1;	// 1 is on, 0 - off
int soundonoff = 0;	// 1 is on, 0 - off

int stack_input = 1;	// input by getc()
int stack_input_sav = 1;	// save for stack_input

int immediate = 0;	// how interpret characters
int immediate_sav = 0;	// save for "immediate" while doing "\input"

char inputline[MAXINPUTLINE];	// input line in stack_input input
char newline[MAXINPUTLINE];	// line for line editor
char saveline[MAXLINES+1][MAXINPUTLINE];	// array of previous input lines
int lastline = 0;	// number of last introduced line in array "saveline"
int inp_pointer1;	// pointer after stack_input input
int line_read = 0;	// line has been read (for stack_input input)

int output_open = 0;	// output file has been open
FILE *fout;	// output file pointer

int input_file = 0;	// input from the file
#define MAXFINP 30	// maximum number of input files
FILE *finp[MAXFINP+1];	// stack for input files

char cpause;

char curfile[LPARAM];	// current file
char me_curfile[LPARAM+30];	// to edit current file

int lnew;	// input line length

int shifted = 0;	// all frequences are shifted at...

char editor[LPARAM];	// full name of the DOS editor
char norton[LPARAM];	// full name of the Norton Commander

int circularly = 0;	// flag to play file circularly
int input_remain = 0;	// now many times to play file

//--- functions:

int callmacro(void);
int getsymbol(void);
int namecomp(char *str);
int paramcomp(int nparam, char *str);
int input_ini(void);
int mac_input_close(void);
int linenum(int lineshift);
int init_saveline(void);
int char_insert(char cc);
int char_delete(void);
int mac_write_newline(void);

int mac_exit();
int mac_sound(void);
int mac_immediate(void);
int mac_literally(void);
int mac_output(void);
int mac_open(void);
int mac_close(void);
int mac_write(void);
int mac_input(void);
int mac_circle(void);
int mac_read(void);
int mac_file(void);
int mac_dos(void);
int mac_pause(void);
int mac_shift(void);
int mac_stack_input(void);
int mac_set(void);
int mac_show(void);
int mac_norton(void);
int mac_editor(void);
int mac_help(void);
int mac_comment(void);
int mac_note(void);
int mac_pianino(void);
int mac_dummy(void);


//==================================================
	int callmacro(void)
//==================================================
/*
	Calls macro after backslash.
*/
//--------------------------------------------------
{
//char namemacro[32];
int namepointer;
int parampointer;
int iparam = 0;
//..................................................

namepointer = 0;

while(c!='{'&&c!='\n') {
  namemacro[namepointer++] = c;
  if(namepointer==LPARAM) {
    printf("\nToo long macro name.\n");
    return 0;
    }
  c = getsymbol();
  }
namemacro[namepointer] = 0;

if(c=='\n') {
  nparams = 0;
  goto jump;
  }

strcpy(param[0],namemacro);

for(iparam=1;iparam<=MAXPARAM;iparam++) {

  parampointer = 0;

  c = getsymbol();	// to pass "{"
  while(c!='}') {
    param[iparam][parampointer++] = c;
    if(parampointer==LPARAM) {
      printf("\nToo long parameter name.\n");
      return 0;
      }
    c = getsymbol();
    }
  param[iparam][parampointer] = 0;

  c = getsymbol();	// to pass "}"

//  printf("c after param is %c,iparam=%d,MAXPARAM=%d\n",c,iparam,MAXPARAM);

  if(c!='{') break;

  }

nparams = iparam;

jump:

//printf("nparams = %d\n",nparams);
//for(int i=1;i<=MAXPARAM;i++) printf("param[%d] = \"%s\"\n",i,param[i]);

//printf("namemacro = %s, param = %s\n",namemacro,param);

if(namecomp("exit")) {
  //printf("before mac_exit call...\n");
  mac_exit();
} else if(namecomp("quit")) {
  mac_exit();
} else if(namecomp("stop")) {
  mac_exit();
} else if(namecomp("bye")) {
  mac_exit();
} else if(namecomp("sound")) {
  mac_sound();
} else if(namecomp("immediate")) {
  mac_immediate();
} else if(namecomp("defaults")) {
  defaults();
} else if(namecomp("literally")) {
  mac_literally();
} else if(namecomp("output")) {
  mac_output();
} else if(namecomp("open")) {
  mac_open();
} else if(namecomp("close")) {
  mac_close();
} else if(namecomp("write")) {
  mac_write();
} else if(namecomp("input")) {
  mac_input();
} else if(namecomp("circle")) {
  mac_circle();
} else if(namecomp("read")) {
  mac_read();
} else if(namecomp("file")) {
  mac_file();
} else if(namecomp("dos")) {
  mac_dos();
} else if(namecomp("pause")) {
  mac_pause();
} else if(namecomp("shift")) {
  mac_shift();
} else if(namecomp("stack_input")) {
  mac_stack_input();
} else if(namecomp("set")) {
  mac_set();
} else if(namecomp("show")) {
  mac_show();
} else if(namecomp("editor")) {
  mac_editor();
} else if(namecomp("norton")) {
  mac_norton();
} else if(namecomp("help")) {
  mac_help();
} else if(namecomp("comment")) {
  mac_comment();
} else if(namecomp("note")) {
  mac_note();
} else if(namecomp("pianino")) {
  mac_pianino();
} else if(namecomp("dummy")) {
  mac_dummy();
//} else if(namecomp("exit")) {
//  mac_exit();
} else {
  printf("\nUnknown macro %s\n",param[0]);
  }

//printf("after macro call...\n");

return 0;

}


//==================================================
	int namecomp(char *str)
//==================================================
/*
	Compares string "str" with a "namemacro".
	Returns 1 if they coincide, 0 otherwise.
*/
//--------------------------------------------------
{

//..................................................
//printf("namemacro = %s, str = %s.\n",namemacro,str);
//printf("namecomp returns %d\n",!strcmp(namemacro,str));
return !strcmp(namemacro,str);

}


//==================================================
	int paramcomp(int nparam, char *str)
//==================================================
/*
	Compares string "str" with a "param[nparam]".
	Returns 1 if they coincide, 0 otherwise.
*/
//--------------------------------------------------
{

//..................................................
if(nparam<=nparams) return !strcmp(param[nparam],str);
else return 0;

}


//==================================================
	int getsymbol(void)
//==================================================
/*
	Returns next character.
*/
//--------------------------------------------------
{
int digit;
char c1 = 0;
int itmp;
int i;
int relative = 1;
char ctmp;

int y,x;
//..................................................


//if(stack_input) return getche();
//else return getc(fp);

if(fp!=stdin&&stack_input) stack_input = 0;

if(stack_input) {

  //printf("line_read in getsymbol is %d\n", line_read);

  if(!line_read) {
nextline:
    for(;c1!=13;) {	// 13 is RET from getche
      y = wherey();
      c1 = getch();
//      printf("character was a %c, code %d.",c1,c1);

      switch(c1) {
      case 0:
	c1 = getch();
	switch (c1) {
	case 75:	// left arrow
//	  printf("left arrow, x=%d");
	  gotoxy(wherex()-1,y);
	  break;
	case 77:	// right arrow
	  x = wherex();
	  gotoxy(++x,y);
	  for(;x-->strlen(newline)+1;) {
	    newline[x-1] = ' ';
	    }
	  break;
	break;
	case 71:	// home
	  gotoxy(1,y);
	  break;
	case 79:	// end
	  gotoxy(strlen(newline)+1,y);
	  break;
	case 72: 	// up arrow
	  strcpy(newline,saveline[linenum(--relative)]);
	  printf("\r%-78s\r%s","",newline);
	  break;
	case 80: 	// down arrow
	  strcpy(newline,saveline[linenum(++relative)]);
	  printf("\r%-78s\r%s","",newline);
	  break;
	case 73: 	// page up
	  relative -= 10;
	  strcpy(newline,saveline[linenum(relative)]);
	  printf("\r%-78s\r%s","",newline);
	  break;
	case 81: 	// page down
	  relative += 10;
	  strcpy(newline,saveline[linenum(relative)]);
	  printf("\r%-78s\r%s","",newline);
	  break;
	case 83:	// delete right
	  movetext(wherex()+1,y,80,y,wherex(),y);
	  char_delete();
	  break;
	case 59:	// F1
	  mac_help();
	  break;
	case 60:	// F2
	  if(norton[0]) {
	    system(norton);
	  } else {
	    system("nc");
	    }
	  break;
	case 61:	// F3
	  break;
	case 62:	// F4
	  if(editor[0]) {
	    strcpy(me_curfile,editor);
	  } else {
	    strcpy(me_curfile,"me ");
	    }
	  strcat(me_curfile,curfile);
	  system(me_curfile);
	  break;
	case 63:	// F5
	  printf("---writing---");
	  mac_write_newline();
	  break;
	case 64:	// F6
	  break;
	case 65:	// F7
	  break;
	case 66:	// F8
	  break;
	case 67:	// F9
	  break;
	case 68:	// F10
	  break;
	  }
	break;

      case 27:	// ESC - reset line
	strcpy(newline,"");
	printf("\r%-78s\r%s","",newline);
	relative = 1;
	break;

      case 18:	// Ctrl+R - restore line
	printf("\r%-78s\r%s","",newline);
	break;

      case 8:	// delete left
//	printf("delete");
	movetext(wherex(),y,80,y,wherex()-1,y);
	gotoxy(wherex()-1,y);
	char_delete();
	break;

      case 3:	// Ctrl+C - exit
	exit(1);

      case 26:	// Ctrl+Z - end playing file(s) - not works
//	printf("Closing files");
	while(input_file) {
	  mac_input_close();
	  }
	c1 = '\n';
	break;

      case 13:	// CR

	ctmp = newline[strlen(newline)-1];
	if(ctmp=='\\'||ctmp=='/') {
	  strcpy(inputline,"");
	  lnew = 0;
	} else {
	  strcpy(inputline,newline);
	  strcat(inputline,"\n");
	  lnew = strlen(newline);
	  }

//	printf("\ninputline is \"%s\"\n",inputline);
	printf("\n");
	break;

      default:
	movetext(wherex(),y,79,y,wherex()+1,y);
	putch(c1);
	char_insert(c1);

	if(immediate) {

	  if(isrdigit(c1)) {
	    digit = c1 - 48;
	    itmp = wherex() - 2;	// 2 because cursor moved after putch(c1)
//	    printf("\nitmp:%d",itmp);
	    if(itmp) {
	      if(newline[itmp-1]=='/') {
		digit += 10;
		itmp--;
		}
	      if(itmp) {
		if(newline[itmp-1]=='-') {
		digit *= -1;
		  }
		}
	      }
//	    printf("digit in getsymbol is %d.\n",digit);
	    note(digit,longdef);
	    }
	  }
	}
      }
    if(!strcmp(newline,"")) {
      c1 = 0;	// to be not equal 13
      goto nextline;
      }

    if(strcmp(saveline[lastline],newline)) {
      lastline = linenum(+1);
//    printf("lastline = %d\n",lastline);
      strcpy(saveline[lastline],newline);
      }
    strcpy(newline,"");	// reset newline
    inp_pointer1 = 0;
    line_read = 1;
    }

  if(inp_pointer1==lnew) {
    line_read = 0;
    }

//  printf("getsymbol returns code %d, inp_pointer1 = %d, lnew=%d\n",inputline[inp_pointer1],inp_pointer1,lnew);

  return inputline[inp_pointer1++];

} else {

//  return getc(fp);

//next:
  c1 = getc(fp);
//  printf("character was a %c, code %d.",c1,c1);

  if(input_file&&c1==EOF) {
    if(circularly) rewind(fp);
    else mac_input_close();
//    goto next;
    c1 = '\n';
    }

  return c1;

  }

}


//==================================================
	int linenum(int lineshift)
//==================================================
/*
	Calculates line number = current line + lineshift
	curcularly, that is, if calculated number
	occures to be outer to the saveline array
	bounds, it adds or substracts MAXLINES.

	When shift is more than one circle, returns 0,
	id est, pointer to the blank (null length) line.
*/
//--------------------------------------------------
{
int itmp;
//..................................................

if(abs(lineshift)>MAXLINES) return 0;

itmp = lastline + lineshift;

if(itmp>=MAXLINES) itmp -= MAXLINES;

if(itmp<=0) itmp += MAXLINES;

return itmp;

}


//==================================================
	int init_saveline(void)
//==================================================
/*
	Initializes stack of input lines.
*/
//--------------------------------------------------
{
//..................................................

for(int i=0;i<=MAXLINES;i++) strcpy(saveline[i],"");

return 0;

}


//==================================================
	int char_delete(void) {
//--------------------------------------------------
/*
	Deletes character in the input line.
*/
//--------------------------------------------------
int x = wherex();
//..................................................

if(!x) return 1;

for(;x<=strlen(newline);x++) newline[x-1] = newline[x];

return 0;

}


//==================================================
	int char_insert(char ci) {
//--------------------------------------------------
/*
	Inserts character to the input line.
*/
//--------------------------------------------------

int x = wherex()-1;
int x1=strlen(newline);

//printf("x,x1:%d,%d\n",x,x1);

if(x1==80) return 1;

for(;x1>=x-1;x1--) newline[x1+1] = newline[x1];

newline[x-1] = ci;

return 0;

}
/*
char c1;
int y;

next_line:

y = wherey();

gotoxy(1,y);
printf(line);
strcpy(newline,line);

lennew = strlen(line);
//puttext(1,y,lennew,y,line);

next:

c1 = getch();

switch (c1) {
case 0:
  c1 = getch();
  switch (c1) {
  case 75:	// left
    gotoxy(wherex()-1,y);
    break;
  case 77:	// right
    gotoxy(wherex()+1,y);
    break;
    }
  break;
case 8:	// delete left
  movetext(wherex(),y,80,y,wherex()-1,y);
  gotoxy(wherex()-1,y);
  char_delete();
  break;
case 3: return 0;
case 10:
case 13:	// CR
  printf("\nNew line is a \"%s\"\n",newline);
//  getch();
  goto next_line;
//  return 0;
default:
  movetext(wherex(),y,79,y,wherex()+1,y);
  putch(c1);
  char_insert(c1);
  }

goto next;

return 0;

}

*/


//**************************************************


//==================================================
	int mac_exit()
//==================================================
/*
	Exits the program.
*/
//--------------------------------------------------

//..................................................
{
exit(0);

return 0;
}


//==================================================
	int mac_sound(void)
//==================================================
/*
	Turns sound on or off.
*/
//--------------------------------------------------

//..................................................
{

//printf("mac_sound called\n");

if(paramcomp(1,"on")) {
  soundonoff = 1;
  immediate = immediate_sav;
} else if(paramcomp(1,"off")) {
  soundonoff = 0;
  immediate_sav = immediate;
  immediate = 0;
  }
else {
  printf("\nValid parameters to macro \"sound\" are {on} and {off}.\n");
  return 1;
  }

return 0;

}

//==================================================
	int mac_literally(void)
//==================================================
/*
	Sends parameters to the screen.
*/
//--------------------------------------------------
{
int i;
//..................................................

for(i=1;i<=nparams;i++) printf(param[i]);

return 0;

}


//==================================================
	int mac_stack_input(void)
//==================================================
/*
	Turns flag to use stack for input lines or
	to input simply by getc().
*/
//--------------------------------------------------
{
//..................................................

if(paramcomp(1,"on")) {
  if(input_file) stack_input_sav = 1;
  else stack_input = 1;
  }
else if(paramcomp(1,"off")) {
  if(input_file) stack_input_sav = 0;
  else stack_input = 0;
  }
else {
  printf("\nValid parameters to macro \"stack_input\" are {on} and {off}.\n");
  return 1;
  }

//printf("Stack_input & stack_input_sav is now %d & %d\n", stack_input, stack_input_sav);

return 0;

}


//==================================================
	int mac_output(void)
//==================================================
/*
	Opens output file specified by first
	parameter or closes it if no parameter
	or null parameter specified.
*/
//--------------------------------------------------
{
//..................................................
if(nparams>1) {
  printf("\nYou should suplay no more than 1 parameter for macro \output\n");
  }

//printf("param[1]=%s.\n",param[1]);

if(fclose(fout)) {
//  printf("\nPromlems with closing output file.\n");
//  return 1;
  }
output_open = 0;

if(param[1][0]==0||paramcomp(1,"off")) {
} else {
  if((fout = fopen(param[1],"wt")) == NULL) {
    printf("\nI can't open output file %s.\n",param[1]);
    return 1;
    }
  strcpy(curfile,param[1]);
  output_open = 1;
  }

return 0;

}


//==================================================
	int mac_open(void)
//==================================================
/*
	Opens output file specified by first
	parameter. Differs from mac_output only by
	that mac_output with no parameters closes
	output file, and mac_open opens file cutfile.
*/
//--------------------------------------------------
{
//..................................................
if(nparams>1) {
  printf("\nYou should supplay no more than 1 parameter for macro \output\n");
  }

//printf("param[1]=%s.\n",param[1]);

if(fclose(fout)) {
//  printf("\nPromlems with closing output file.\n");
//  return 1;
  }
output_open = 0;

if(!paramcomp(1,"")&&nparams) strcpy(curfile,param[1]);

if((fout = fopen(curfile,"wt")) == NULL) {
  printf("\nI can't open output file %s.\n",curfile);
  return 1;
  }
output_open = 1;

return 0;

}


//==================================================
	int mac_close(void)
//==================================================
/*
	Closes output file.
*/
//--------------------------------------------------
{
//..................................................

if(fclose(fout)) {
//  printf("\nPromlems with closing output file.\n");
//  return 1;
  }
output_open = 0;

return 0;

}


//==================================================
	int mac_write(void)
//==================================================
/*
	Writes last played line to the output file.
*/
//--------------------------------------------------
{
//..................................................

if(!output_open) {
  printf("\nYou must previously open output file by command \output.\n");
  return 1;
  }

//fprintf(fout,saveline1);
//printf("I'm going to write:\n%s",saveline[linenum(-1)]);
fprintf(fout,saveline[linenum(-1)]);
fprintf(fout,"\n");

return 0;

}


//==================================================
	int mac_write_newline(void)
//==================================================
/*
	Writes current line to the output file.
*/
//--------------------------------------------------
{
//..................................................

if(!output_open) {
  printf("\nYou must previously open output file by command \output.\n");
  return 1;
  }

fprintf(fout,newline);
fprintf(fout,"\n");

return 0;

}


//==================================================
	int mac_input(void)
//==================================================
/*
	Determines that input now will be from the
	file defined as first parameter.
*/
//--------------------------------------------------
{
int times = 1;
//..................................................

//printf("Now in mac_input.\n");

if(nparams>1) {
  if((sscanf(param[2],"%d",&times)!=1)) {
    printf("\nI can't read your second parameter %s\n",param[2]);
    return 1;
    }
  }

while(times--) {

  if(input_file==MAXFINP) {
    printf("\nSorry, too many input files.\n");
    return 1;
    }

  if(input_file==0) {
    stack_input_sav = stack_input;
    }

  if(!paramcomp(1,"")&&nparams) strcpy(curfile,param[1]);

  if((finp[input_file+1]=fopen(curfile,"r"))==NULL) {
    printf("\nSorry, I can't open file %s.\n",curfile);
    return 2;
    }

  fp = finp[++input_file];

  }

stack_input = 0;
new_line = 1;

return 0;

}

//==================================================
	int mac_input_close(void)
//==================================================
/*
	Closes input file for mac_input.
*/
//--------------------------------------------------
{
//..................................................

if(input_file==0) {
  printf("\nSorry, closing of the input file now is not correct.\n");
  return 1;
  }

fclose(finp[input_file--]);

fp = finp[input_file];

if(input_file==0) {
  stack_input = stack_input_sav;
  }

if(new_line_sav) {
  new_line_sav--;
  new_line = 1;
  }

return 0;

}


//==================================================
	int input_ini(void)
//==================================================
/*
	At beginning of program run or at \defaults
	macro commands to execute files "notes.not"
	from the directory containing program and
	"notini.not" from the current directory.
*/
//--------------------------------------------------
{
char notes_not[100];
char* notini_not = "notini.not";

int i;
//..................................................

strcpy(notes_not,_argv[0]);

for(i=strlen(notes_not);notes_not[i]!='\\'&&i>0;i--);	// ">0" for stability

notes_not[i+1] = 0;

strcat(notes_not,"notes.not");

if((finp[input_file+1]=fopen(notini_not,"r"))==NULL) {
  //printf("\nSorry, I can't open file %s.\n",notini_not);
} else {
  if(input_file==MAXFINP) {
    printf("\nSorry, too many input files.\n");
    return 1;
    }
  input_file++;
  new_line_sav++;
  }

if((finp[input_file+1]=fopen(notes_not,"r"))==NULL) {
  printf("\nSorry, I can't open file %s.\n",notes_not);
} else {
  if(input_file==MAXFINP) {
    //printf("\nSorry, too many input files.\n");
    return 1;
    }
  input_file++;
  new_line_sav++;
  }

//printf("input_file in input_ini = %d.\n",input_file);

fp = finp[input_file];

return 0;

}


//==================================================
	int mac_help(void)
//==================================================
/*
	Calls typing of the help file.
*/
//--------------------------------------------------
{
char notes_hlp[100];

int i;
//..................................................

strcpy(notes_hlp,"type ");
strcat(notes_hlp,_argv[0]);

for(i=strlen(notes_hlp);notes_hlp[i]!='\\'&&i>0;i--);	// ">0" for stability

notes_hlp[i+1] = 0;

strcat(notes_hlp,"notes.hlp | more");

system(notes_hlp);

return 0;

}


//==================================================
	int mac_dos(void)
//==================================================
/*
	Executes one dos command.
*/
//--------------------------------------------------

//..................................................
{
if(nparams) return system(param[1]);

printf("\nNo parameters supplied for macro \"dos\".\n");

return -1;

}


//==================================================
	int mac_pause(void)
//==================================================
/*
	Sets character for pause - it is first
	character of the first parameter.
*/
//--------------------------------------------------
{
//..................................................

cpause = param[1][0];

return 0;

}


//==================================================
	int mac_read(void)
//==================================================
/*
	Reads contents of the file defined as the
	first parameter to the stack of the input
	lines.
*/
//--------------------------------------------------
{
FILE *fileread;
char readline[MAXINPUTLINE];
int cr;
//..................................................

if(!paramcomp(1,"")&&nparams) strcpy(curfile,param[1]);

if((fileread=fopen(curfile,"r"))==NULL) {
  printf("\nSorry, I can't open file %s.\n",curfile);
  return 2;
  }

while(fgets(readline,80,fileread)) {
//  printf("read\"%s\"\n",readline);
  if(readline[cr=(strlen(readline)-1)]=='\n') readline[cr] = 0;
  lastline = linenum(+1);
  strcpy(saveline[lastline],readline);
  }

return 0;

}


//==================================================
	int mac_shift(void)
//==================================================
/*
	Shifts notes on the value supplied in the
	first parameter expressed in notes.
	For example, if param[1] = "7" rises all
	notes on 1 octava. User must be shure whether
	resulting frequency is within available
	range, otherwise may occure error.
*/
//--------------------------------------------------
{
int shift;
char ans;
char *ptr;
//..................................................

if((ptr = strchr(param[1],'+'))!=0) {
  if(sscanf(ptr+1,"%d",&shift)!=1) {
    printf("\nI can't read your parameter %s\n",param[1]);
    }
  shift += shifted;
} else {
  if(sscanf(param[1],"%d",&shift)!=1) {
    printf("\nI can't read your parameter %s\n",param[1]);
    }
  }

if(abs(shift)>20) {
  printf("\nAre you shure that shift in %d notes is correct?\n",shift);
  if((ans=getche())=='N'||ans=='n') return 1;
  printf(" OK.\n");
  }

num_note_shift(shift-shifted);

shifted = shift;

return 0;

}


//==================================================
	int mac_immediate(void)
//==================================================
/*
	Turns flag to play notes read immediately
	or not.
*/
//--------------------------------------------------
{
//..................................................

//printf("mac_sound called\n");

if(paramcomp(1,"on")) immediate = 1;
else if(paramcomp(1,"off")) immediate = 0;
else {
  printf("\nValid parameters to macro \"immediate\" are {on} and {off}.\n");
  return 1;
  }

return 0;

}


//==================================================
	int mac_set(void)
//==================================================
/*
	Sets various entities.
*/
//--------------------------------------------------
{
float freq_do;
int full;
//..................................................

if(nparams!=2) {
  printf("\nSupply, please, only 2 parameters for macro \\%s.\n",param[0]);
  }

if(paramcomp(1,"do")) {
  if((sscanf(param[2],"%f",&freq_do)!=1)) {
    printf("\nI can't read your second parameter %s\n",param[2]);
    return 1;
    }
  freq0 = freq_do/DO_DIVIDER;
  init_freq();
  }
else if(paramcomp(1,"full")) {
  if((sscanf(param[2],"%d",&full)!=1)) {
    printf("\nI can't read your second parameter %s\n",param[2]);
    return 1;
    }
  long0 = full/16;
  }
else if(paramcomp(1,"micropause")) {
  if((sscanf(param[2],"%d",&micropause)!=1)) {
    printf("\nI can't read your second parameter %s\n",param[2]);
    return 1;
    }
  }
else if(paramcomp(1,"accel")) {
  if((sscanf(param[2],"%f",&accel_factor)!=1)) {
    printf("\nI can't read your second parameter %s\n",param[2]);
    return 1;
    }
  }
else if(paramcomp(1,"accel_count")) {
  if((sscanf(param[2],"%d",&accel_count)!=1)) {
    printf("\nI can't read your second parameter %s\n",param[2]);
    return 1;
    }
  }
//else if(paramcomp(1,"full")) {
//  }
else {
  printf("Unknown entity for macro \\%s: %s\n",param[0],param[1]);
  }

return 0;

}


//==================================================
	int mac_show(void)
//==================================================
/*
	Shows various entities.
*/
//--------------------------------------------------
{
//..................................................

if(nparams!=1) {
  printf("\nSupply, please, only 1 parameter for macro \\%s.\n",param[0]);
  }

if(paramcomp(1,"do")) {
  printf("\nValue of \"%s\" is %f\n",param[1],freq0*DO_DIVIDER);
  }
else if(paramcomp(1,"full")) {
  printf("\nValue of \"%s\" is %d\n",param[1],long0*16);
  }
else if(paramcomp(1,"micropause")) {
  printf("\nValue of \"%s\" is %d\n",param[1],micropause);
  }
else if(paramcomp(1,"accel")) {
  printf("\nValue of \"%s\" is %f\n",param[1],accel_factor);
  }
else if(paramcomp(1,"accel_count")) {
  printf("\nValue of \"%s\" is %d\n",param[1],accel_count);
  }
//else if(paramcomp(1,"accel")) {
//  }
else {
  printf("Unknown entity for macro \\%s: %s\n",param[0],param[1]);
  }

return 0;

}


//==================================================
	int mac_editor(void)
//==================================================
/*
	Defines editor.
*/
//--------------------------------------------------
{
//..................................................
if(nparams!=1) {
  printf("\nYou should supplay only 1 parameter for macro param[0]\n");
  }

if(param[1][0]==0) {
  strcpy(editor,"");
} else {
  strcpy(editor,param[1]);
  strcat(editor," ");
  }

return 0;

}


//==================================================
	int mac_norton(void)
//==================================================
/*
	Defines path to the Norton Commander.
*/
//--------------------------------------------------
{
//..................................................
if(nparams!=1) {
  printf("\nYou should supplay only 1 parameter for macro param[0]\n");
  }

if(param[1][0]==0) {
  strcpy(norton,"");
} else {
  strcpy(norton,param[1]);
  }

return 0;

}


//==================================================
	int mac_comment(void)
//==================================================
/*
	Parameters of this macro are comments.
*/
//--------------------------------------------------
{
//..................................................

return 0;

}


//==================================================
	int mac_file(void)
//==================================================
/*
	Determines current file.
*/
//--------------------------------------------------
{
//..................................................

strcpy(curfile,param[1]);

return 0;

}


//==================================================
	int mac_note(void)
//==================================================
/*
	Plays note with frequency supplayed as first
	parameter, longitude as second and text as
	third parameter. Second and third parameters
	are optional.
*/
//--------------------------------------------------
{
float freq, dlit, silent;
//..................................................
if(nparams<1||nparams>4) {
  printf("\nYou should supplay 1, 2 or 3 parameters for macro param[0]\n");
  return 1;
  }

if(param[1][0]!=0) {
  if((sscanf(param[1],"%f",&freq)!=1)) {
    printf("\nI can't read your first parameter %s\n",param[1]);
    return 1;
    }
} else {
  freq = PAUSE;
  }

if(nparams>1) {
  if((sscanf(param[2],"%f",&dlit)!=1)) {
    printf("\nI can't read your second parameter %s\n",param[2]);
    return 1;
    }
} else {
  dlit = longdef*long0;
  }

if(nparams>3) {
  if((sscanf(param[4],"%f",&silent)!=1)) {
    printf("\nI can't read your 4th parameter %s\n",param[4]);
    return 1;
    }
} else {
  silent = micropause;
  }

if(nparams>2) printf(param[3]);

//printf("freq=%f,dlit=%f,text=%s,silent=%f",freq,dlit,param[3],silent);

if(freq!=PAUSE) sound(freq);
delay(dlit);
nosound();
delay(silent);

return 0;

}


//==================================================
	int mac_circle(void)
//==================================================
/*
	Plays some file circularly.
*/
//--------------------------------------------------
{
//..................................................

circularly = 1;

mac_input();

return 0;

}


//==================================================
	int mac_pianino(void)
//==================================================
/*
	Numbres on the keyboard work as pianino.
*/
//--------------------------------------------------
{
char c1 = 0;
//..................................................

while(c1!=10&&c1!=27&&c1!=32) {

  }

return 0;

}

//==================================================
	int mac_dummy(void)
//==================================================
/*
	Dummy routine.
*/
//--------------------------------------------------
{
//..................................................
return 0;

}


//==================================================

//==================================================
/*

*/
//--------------------------------------------------

//..................................................
