#!/usr/bin/perl -w
# Author: I.Plisco (igor at plisco dot ru)
# Aim: Converts notes from format of znamen player to format of 'notes'.
# $Id$
#
# Usage: mus2not.pl < file.mus > file.not

use strict;

my(@znotes, @nnotes, %notes, %len, $i, $out, $header);
my($note, $len, $text, $action);

# Definitions
@znotes = qw(Ut1 Re1 Mi1 Ut2 Re2 Mi2 Fa1 Sl1 La1 Fa2 Sl2 La2);
@nnotes = qw(2   3   4   5   6   7   8   9   /0  /1  /2  /3);

# File header
$header = "\\set{micropause}{0}\n";

# Make notes convertation hash
for($i=0; $i <= $#znotes; $i++) {
  $notes{$znotes[$i]} = $nnotes[$i];
}

# Lenghts
%len = (
  1 => '.',
  2 => ',',
  4 => "'",
  8 => "`",
);

# Read input
while (<>) {

# split line
  ($note, $len, $text, $action) = split;

# Make notes "uppercase first"
  $note = ucfirst(lc($note));

# Normalize text
  $text =~ s/(\d)/\\$1/g;
  $text =~ s/-/_/g;

# Convert it
  $out .= $notes{$note}. $len{$len}. $text;
  if($action == 2) {
    $out .= " ";
  } elsif($action == 3) {
    $out .= "\n";
  }

}

# Make output
print $header;
print $out;

